<script>
import { mapState, mapActions } from "vuex";
import ChatMessage from "@/components/ChatMessage.vue";

export default {
  components: {
    ChatMessage,
  },

  data() {
    return {
      text: "",
      messages: [],
      centrifuge: null,

      memberId: "",

      showInfo: false,
    };
  },

  watch: {
    "$route.params.id"() {
      this.loadChatInfo();
    },
  },

  computed: {
    ...mapState({
      authInfo: (state) => state.auth.authInfo,
      user: (state) => state.user.user,
      chat: (state) => state.chat.chat,
      event: (state) => state.events.event,
    }),

    formattedChatName() {
      return this.user.chat_id === parseInt(this.$route.params.id)
        ? this.user?.name !== null
          ? this.user?.name
          : `Организация-${this.user.id}`
        : this.chat.chatable?.name;
    },

    formattedImagePath() {
      return this.user?.chat_id === parseInt(this.$route.params.id)
        ? this.user?.avatar
          ? this.user?.avatar?.url?.full_size
          : require("../assets/logo.svg")
        : this.chat.chatable?.avatar
        ? this.chat?.chatable?.avatar?.url?.full_size
        : require("../assets/logo.svg");
    },

    formattedMembersCount() {
      return this.chat?.members?.length ?? 0;
    },
  },

  methods: {
    ...mapActions({
      sendMessage: "chat/sendMessage",
      loadChat: "chat/loadChat",
      loadEvent: "events/loadEvent",
    }),

    sendMessageRequest() {
      this.sendMessage({
        chatId: this.$route.params.id,
        message: this.text,
      }).then(() => {
        this.text = "";
      });
    },

    loadChatInfo() {
      this.loadChat({ chatId: this.$route.params.id }).then(() => {
        this.messages = this.chat.messages;

        let member = this.chat.members.find((member) => {
          return member?.member?.organization.id === this.user.id;
        });

        if (member) {
          this.memberId = member.id;
        }
      });
    },
  },

  mounted() {
    this.loadChatInfo();

    var Centrifuge = require("centrifuge");

    this.centrifuge = new Centrifuge(
      "wss://mch-centrifugo-c.server.bonch.dev/connection/websocket"
    );

    this.centrifuge.setToken(localStorage.getItem("broadcast-token"));

    const chatId = parseInt(this.$route.params.id);

    this.centrifuge.subscribe(
      `chats:user#organization::${this.user.id}`,
      (message) => {
        if (message.data.message.chat_id === chatId) {
          this.messages = [message.data.message, ...this.messages];
        }
      }
    );

    this.centrifuge.connect();
  },

  beforeDestroy() {
    this.centrifuge.disconnect();
  },
};
</script>

<template>
  <div class="chat">
    <div class="chat__block block-wrapper">
      <v-btn class="mr-2" color="info" @click="$router.go(-1)">
        <v-icon left> mdi-chevron-left </v-icon>
        Назад
      </v-btn>
    </div>

    <div class="chat__block block-wrapper chat-view">
      <div class="chat-view__header">
        <div v-if="chat" class="chat-view__wrapper">
          <div class="chat-view__image mr-4">
            <img :src="formattedImagePath" height="56" alt="" />
          </div>

          <div class="chat-view__info">
            <h5>{{ formattedChatName }}</h5>
            <span>{{ formattedMembersCount }} участников</span>
          </div>
        </div>

        <v-btn icon class="ml-auto" color="gray">
          <v-icon> mdi-cog </v-icon>
        </v-btn>
      </div>

      <v-divider></v-divider>

      <div class="chat-view__messages">
        <chat-message
          v-for="message in messages"
          :key="message.id"
          :message="message"
          :members="chat.members"
          :mine="memberId"
        />
      </div>

      <v-divider></v-divider>

      <v-text-field
        v-model="text"
        class="mt-4"
        append-icon="mdi-send"
        clearable
        outlined
        label="Сообщение"
        type="text"
        @click:append="sendMessageRequest"
      ></v-text-field>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.chat {
  height: 100%;
  overflow: auto;
  display: flex;
  flex-direction: column;
  align-items: center;
  padding: 100px 32px 60px;

  &__block {
    max-width: 570px;
    width: 100%;
    height: fit-content;
    padding: 16px;

    &:not(:last-child) {
      margin-bottom: 24px;
    }
  }

  .chat-view {
    &__header {
      display: flex;
      justify-content: space-between;
      padding: 8px;
      padding-bottom: 24px;
    }

    &__wrapper {
      display: flex;
      align-items: center;
    }

    &__messages {
      height: 450px;
      overflow: auto;
      display: flex;
      flex-direction: column-reverse;
    }

    &__image {
      display: flex;
      max-width: 56px;
      height: 56px;

      img {
        border-radius: 4px;
        width: 100%;
        height: auto;
      }
    }

    &__info {
      h5 {
        font-size: 16px;
        color: #212121;
        margin-bottom: 8px;
      }

      span {
        border-radius: 30px;
        border: 1px solid #179de3;
        padding: 4px 10px;
        color: #179de3;
        font-size: 12px;
      }
    }
  }
}
</style>
